/*
 * Project Name:upay-sdk-web
 * File Name:SubMerchantQueryServlet.java
 * Package Name:com.upay.sdk.declaration.v_3.SubMerchantQueryServlet
 * Date:2019-05-22 13:46:46
 * Copyright (c) 2019, upay All Rights Reserved.
 */

package com.upay.sdk.declaration;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson15.JSONObject;
import com.upay.sdk.declaration.v_3.subMerchant.builder.SubMerchantQueryBuilder;
import com.upay.sdk.declaration.v_3.subMerchant.executer.SubMerchantDeclareExecuter;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;

public class SubMerchantQueryServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String merchantId = req.getParameter("merchantId");
        String subMerchantId = req.getParameter("subMerchantId");

        SubMerchantQueryBuilder builder = new SubMerchantQueryBuilder(merchantId);
        builder.setSubMerchantId(subMerchantId);

        final PrintWriter out = resp.getWriter();

        SubMerchantDeclareExecuter executer = new SubMerchantDeclareExecuter();
        try{
            executer.bothSubMerchantQuery(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        }
        catch(ResponseException e){
            out.println("响应异常</br>");
            out.println(e.toString());
        }
        catch(HmacVerifyException e){
            out.println("签名验证异常</br>");
            out.println(e.toString());
        }
        catch(RequestException e){
            out.println("请求异常</br>");
            out.println(e.toString());
        }
        catch(UnknownException e){
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
